/*
 SimpleCDR-X Copyright (C) 2001 John Tobin

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 If you would like to negotiate alternate licensing terms, you may do
 so by contacting the author: John Tobin <ogre@sirinet.net>
 */

#include <gtk/gtk.h>
#include "simplecdr.h"

#ifndef __CALLBACKS_H__
#define __CALLBACKS_H__


void
on_add_playlist_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
on_add_file_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_rip_n_add_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_delete_all_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_play_cd_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
on_burn_audio_clicked                        (GtkButton       *button,
                                        gpointer         user_data);

void
on_aud_burn_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_aud_abort_button_clicked                (GtkButton       *button,
                                        gpointer         user_data);
void
on_copy_audio_button_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_rip_sel_wav_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_rip_all_wav_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_play_cd_track_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_rip_sel_enc_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_rip_all_enc_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_encode_ind_button_clicked                  (GtkButton       *button,
                                        gpointer         user_data);
void on_encode_ind_clicked                  (GtkButton       *button,
                                        gpointer         user_data);
void
on_enc_wav_entry_changed               (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_enc_sel_entry_changed               (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_rip_sel_wav_entry_changed           (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_cd_track_sel_spin_changed           (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_rip_cd_wav_entry_changed            (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_enc_cd_entry_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_copy_data_mkisofs_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_copy_with_cdrdao_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_add_file_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_add_playlist_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
on_cancel_button_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_save_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void main_menu(GtkWidget*, Setup);


void setupvalues(int&);

void
on_cd_stop_button_clicked              (GtkButton       *button,
                                        gpointer         user_data);
void encode_music_file(string);

void
on_filesel_ok_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_cancel_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_delete_clicked                      (GtkButton       *button,
                                        gpointer         user_data);

void
on_audio_list_select_row               (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

gboolean
on_SimpleCDR_X_destroy_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_cd_stop_button_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_simulate_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_add_dir_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
on_add_dir_contents_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_delete_file_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void mkisofs_options();

void
on_mkisofs_button1_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_mkisofs_button2_clicked             (GtkButton       *button,
                                        gpointer         user_data);
void
on_write_image_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_blank_cdrw_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_delete_all_file_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_add_file_data_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_blank_fast_button_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_blank_slow_button_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

gboolean
on_SimpleCDR_X_destroy_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_new_dir_ok_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_new_dir_cancel_clicked              (GtkButton       *button,
                                        gpointer         user_data);

//void add_file(string);

void
on_cancel_data_button_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void
on_dir_master_list_select_row          (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);


gboolean
on_dir_master_list_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);




void
on_data_master_list_select_row         (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

//void refresh_list();                                        

void
on_remove_dir_button_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_cd_image_load_button_clicked        (GtkButton       *button,
                                        gpointer         user_data);

void
on_save_image_button_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_cancel_button_cd_image_clicked      (GtkButton       *button,
                                        gpointer         user_data);

void
on_cancel_button_cd_image_save_clicked (GtkButton       *button,
                                        gpointer         user_data);

//void cd_image_load_file(string);

//void cd_image_save_file(string);


void
on_add_directory_data_clicked          (GtkButton       *button,
                                        gpointer         user_data);


void progress_show();

void bad_data_show();

void
on_ok_button_finished_clicked          (GtkButton       *button,
                                        gpointer         user_data);
void
on_bad_data_button_clicked             (GtkButton       *button,
                                        gpointer         user_data);
void burn_conf_show();

void
on_size_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_auto_detect_clicked                 (GtkButton       *button,
                                        gpointer         user_data);
void
on_burn_yes_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_hell_no_burn_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
on_play_cd_master_clicked              (GtkButton       *button,
                                        gpointer         user_data);


void
on_stdout_stop_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_iso_image_burn_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_iso_filesel_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_copy_multi_ok_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_copy_multi_cancel_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_on_the_fly_button_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_save_tracklist_button_clicked       (GtkButton       *button,
                                        gpointer         user_data);

void
on_copy_burn_button_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_copy_abort_button_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void copy_cdrdao_show();

void copy_options_show();
void
on_hidden_yes_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_hidden_no_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_dao_button_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data);


gboolean
on_dir_master_list_dc_row              (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);
                                        
void dir_select(string); 
                                        
                                        

void
on_dir_save_button_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_create_bin_image_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_burn_bin_image_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_create_iso_image_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_select_bin_filename_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void
on_select_bin_burn_mage_clicked        (GtkButton       *button,
                                        gpointer         user_data);

void
on_select_iso_filename_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void
on_select_bin_burn_image_clicked       (GtkButton       *button,
                                        gpointer         user_data);

void
on_button78_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_sel_dir_button_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_refresh_mp3list_button_clicked      (GtkButton       *button,
                                        gpointer         user_data);

void
on_genre_list_button_clicked           (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_mp3_clist_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

void
on_mp3_clist_select_row                (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_save_tag_button_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_ok_button_finished_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void
on_viewlog_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
on_burn_bin_clicked                    (GtkButton       *button,
                                        gpointer         user_data);
									

void
on_stdout_stop_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_progress_detail_clicked             (GtkButton       *button,
                                        gpointer         user_data);
void
on_data_master_list_drag_data_received (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);


void
on_data_master_list_drag_drop          (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);


void
on_audio_list_drag_data_received       (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_simplecdrtabs_switch_page           (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data);

void
on_dir_master_list_drag_data_received  (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void
on_view_log1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_audio1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_cdrecord1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_cdrdao1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_create1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_burn4_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_create2_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_burn3_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_About_website_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

gboolean
on_SimpleCDR_X_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_button110_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_cancel_image_button_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void
on_image_ok_button_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_browse_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

#endif // __CALLBACKS_H__

void
on_button108_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_blank_fast_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_blank_slow_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_blank_yes_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_blank_no_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_create_image_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
on_mkiso_close_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_mkisofs_create_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_mkiso_ok_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_rip_cdinfo_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_rip_info_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_rip_cddb_clicked                    (GtkButton       *button,
                                        gpointer         user_data);
void sf_cd_play_button_clicked( GtkWidget *widget, gpointer callback_data );


void
on_stop_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_rip_tracks_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_audio_list_event                    (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_cddb_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
rip_info_clicked                       (GtkButton       *button,
                                        gpointer         user_data);

void
on_cddb_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_rip_info_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_selall_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_rip_scan_cd_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_rip_and_add_clicked                 (GtkButton       *button,
                                        gpointer         user_data);
