/*
   id3.h - Headers for id3.c

    Copyright (C) 2000  Cedric Tefft <cedric@earthling.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  ***************************************************************************

  This file is based in part on:
*/
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <unistd.h>
#include <iostream>
#include <fstream>
#include <string>
#include <cstdlib>

#include "masteraudiocd.h"
#include "string2int.h"
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "mp3info.h"
#include "mp3tech.h"

using namespace std;

#ifndef __ID3_H__
#define __ID3_H__

class id3Tag
{
public:

id3Tag();
void writeTag(GtkWidget*, char*);
void readTag(GtkWidget*, char*);
void writeRippedTag(GtkWidget*, const char*, const char*);
void readOggTag(GtkWidget*, string);
void writeOggTag(GtkWidget*, string);
private:
mp3info mp3_;
char bitRate[30], length[30], fileSize[30];
};

#endif //__ID3_H__

